C
C     Driver program for subroutine ELF1:
C     computation of the exact log-likelihood function of a
C     vector ARMA model.
C
      PROGRAM DRV311DP
C
C     Parameters depend on the dimension of the model
C
      PARAMETER ( IM = 4, M = 2, IP = 1, IQ = 1, N = 50,
     *            NWS = 1000, NIWS = 100 )
C
      INTEGER   IFAULT, IWS(NIWS)
      DOUBLE PRECISION
     *          PHI(IM,IP*M+1), THETA(IM,IQ*M+1), QQ(IM,M), MU(M),
     *          W(IM,N), A(IM,N), XITOL, F1, F2, SIGMA2, LOGELF, WS(NWS)
      LOGICAL   ISMU, ATF
      EXTERNAL  ELF1, REPORT
C
C     Data set (all models)
C
      W(1,1)     =  0.01864
      W(1,2)     = -0.00098
      W(1,3)     = -0.02042
      W(1,4)     = -0.04214
      W(1,5)     =  0.02411
      W(1,6)     = -0.01575
      W(1,7)     = -0.00888
      W(1,8)     =  0.02258
      W(1,9)     =  0.00614
      W(1,10)    =  0.01745
      W(1,11)    =  0.03086
      W(1,12)    =  0.02520
      W(1,13)    = -0.00713
      W(1,14)    =  0.04299
      W(1,15)    =  0.03284
      W(1,16)    = -0.01539
      W(1,17)    = -0.01198
      W(1,18)    =  0.01512
      W(1,19)    =  0.04598
      W(1,20)    = -0.00257
      W(1,21)    = -0.05331
      W(1,22)    = -0.03500
      W(1,23)    =  0.00584
      W(1,24)    =  0.02234
      W(1,25)    =  0.00703
      W(1,26)    = -0.00635
      W(1,27)    = -0.03404
      W(1,28)    = -0.03842
      W(1,29)    = -0.00441
      W(1,30)    =  0.03027
      W(1,31)    =  0.01864
      W(1,32)    = -0.00098
      W(1,33)    = -0.02042
      W(1,34)    = -0.04214
      W(1,35)    =  0.02411
      W(1,36)    = -0.01575
      W(1,37)    = -0.00888
      W(1,38)    =  0.02258
      W(1,39)    =  0.00614
      W(1,40)    =  0.01745
      W(1,41)    =  0.03086
      W(1,42)    =  0.02520
      W(1,43)    = -0.00713
      W(1,44)    =  0.04299
      W(1,45)    =  0.03284
      W(1,46)    = -0.01539
      W(1,47)    = -0.01198
      W(1,48)    =  0.01512
      W(1,49)    =  0.04598
      W(1,50)    = -0.00257
C
      W(2,1)     =  0.01864
      W(2,2)     = -0.00098
      W(2,3)     = -0.02042
      W(2,4)     = -0.04214
      W(2,5)     =  0.02411
      W(2,6)     = -0.01575
      W(2,7)     = -0.00888
      W(2,8)     =  0.02258
      W(2,9)     =  0.00614
      W(2,10)    =  0.01745
      W(2,11)    =  0.03086
      W(2,12)    =  0.02520
      W(2,13)    = -0.00713
      W(2,14)    =  0.04299
      W(2,15)    =  0.03284
      W(2,16)    = -0.01539
      W(2,17)    = -0.01198
      W(2,18)    =  0.01512
      W(2,19)    =  0.04598
      W(2,20)    = -0.00257
      W(2,21)    = -0.05331
      W(2,22)    = -0.03500
      W(2,23)    =  0.00584
      W(2,24)    =  0.02234
      W(2,25)    =  0.00703
      W(2,26)    = -0.00635
      W(2,27)    = -0.03404
      W(2,28)    = -0.03842
      W(2,29)    = -0.00441
      W(2,30)    =  0.03027
      W(2,31)    =  0.01864
      W(2,32)    = -0.00098
      W(2,33)    = -0.02042
      W(2,34)    = -0.04214
      W(2,35)    =  0.02411
      W(2,36)    = -0.01575
      W(2,37)    = -0.00888
      W(2,38)    =  0.02258
      W(2,39)    =  0.00614
      W(2,40)    =  0.01745
      W(2,41)    =  0.03086
      W(2,42)    =  0.02520
      W(2,43)    = -0.00713
      W(2,44)    =  0.04299
      W(2,45)    =  0.03284
      W(2,46)    = -0.01539
      W(2,47)    = -0.01198
      W(2,48)    =  0.01512
      W(2,49)    =  0.04598
      W(2,50)    = -0.00257
C
C     Matrix Q (all models)
C
      QQ(1,1) =  999.0
      QQ(2,1) =   -9.0
      QQ(2,2) =    0.1
C
C     Other parameters (all models); see ELF1 structure
C
      ISMU   = .FALSE.
      ATF    = .TRUE.
      SIGMA2 = 1.0
      XITOL  = -1.0E-4
C
C     [1]: Well-conditioned model
C
      PHI(1,1)   =  0.30
      PHI(2,1)   =  0.00
      PHI(1,2)   =  0.00
      PHI(2,2)   =  0.50
C
      THETA(1,1) = -0.60
      THETA(2,1) =  0.00
      THETA(1,2) =  0.00
      THETA(2,2) = -0.30
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[1]: WELL-CONDITIONED MODEL'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C     [2]: Non-stationary model I (non-computable covariances)
C
      PHI(1,1) =  1.00
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[2]: NON-STATIONARY MODEL (I)'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C     [3]: Non-stationary model II (strictly non-stationary)
C
      PHI(1,1) =  1.01
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[3]: NON-STATIONARY MODEL (II)'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C     [4]: Strictly non-invertible model
C
      PHI(1,1)   =  0.30
      THETA(2,2) = -1.01
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[4]: STRICTLY NON-INVERTIBLE MODEL'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C     [5]: Overparameterized model
C
      THETA(2,2) =  0.50
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[5]: OVERPARAMETERIZED MODEL'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C
C     [6]: Overparameterized model (canceled)
C
      PHI(2,2)   =  0.00
      THETA(2,2) =  0.00
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[6]: OVERPARAMETERIZED MODEL (CANCELED)'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C     [7]: Nearly non-stationary model
C
      PHI(2,2)   =  0.99
      THETA(2,2) = -0.30
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[7]: NEARLY NON-STATIONARY MODEL'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
C     [8]: Nearly non-invertible model
C
      PHI(2,2)   =  0.50
      THETA(2,2) = -0.99
C
      CALL ELF1( 2, IM, IP, IQ, N, W, PHI, THETA, QQ, ISMU, MU,
     *           ATF, A, SIGMA2, XITOL, LOGELF, F1, F2,
     *           WS, NWS, IWS, NIWS, IFAULT )
C
      WRITE(*,*)
      WRITE(*,'(1X,A)') '[8]: NEARLY NON-INVERTIBLE MODEL'
      CALL REPORT( IFAULT, F1, F2, LOGELF, N, 2, IM, A )
C
      END
C
C
C
      SUBROUTINE REPORT( IFAULT, F1, F2, LOGELF, N, M, IM, A )
C
      INTEGER    IFAULT, N, M, IM, I, J
      DOUBLE PRECISION
     *           F1, F2, LOGELF, A(IM,N)
C
      IF (IFAULT .EQ. 0) THEN
C
         WRITE(*,*) '     SUM OF SQUARES = ', F1
         WRITE(*,*) '     DETERMINANT    = ', F2
         WRITE(*,*) '     LOG LIKELIHOOD = ', LOGELF
C
         OPEN( 10, FILE = 'DRV311DP.OUT' )
         DO 10 J = 1, N
         WRITE( 10, '(6F20.8)' ) ( A(I,J), I = 1, M )
   10    CONTINUE
   20    CONTINUE
         CLOSE( 10 )
C
      ELSEIF (IFAULT .EQ. 1) THEN
         WRITE(*,*) '     M < 1'
      ELSEIF (IFAULT .EQ. 2) THEN
         WRITE(*,*) '     N < 1'
      ELSEIF (IFAULT .EQ. 3) THEN
         WRITE(*,*) '     P < 0'
      ELSEIF (IFAULT .EQ. 4) THEN
         WRITE(*,*) '     Q < 0'
      ELSEIF (IFAULT .EQ. 5) THEN
         WRITE(*,*) '     P = 0 AND Q = 0'
      ELSEIF (IFAULT .EQ. 6) THEN
         WRITE(*,*) '     IM < M'
      ELSEIF (IFAULT .EQ. 7) THEN
         WRITE(*,*) '     INSUFFICIENT REAL WORKSPACE'
      ELSEIF (IFAULT .EQ. 8) THEN
         WRITE(*,*) '     INSUFFICIENT INTEGER WORKSPACE'
      ELSEIF (IFAULT .EQ. 9) THEN
         WRITE(*,*) '     Q NON P.D.'
      ELSEIF (IFAULT .EQ. 10) THEN
         WRITE(*,*) '     SINGULAR SYSTEM FOR AUTOCOVARIANCES'
      ELSEIF (IFAULT .EQ. 11) THEN
         WRITE(*,*) '     NON-STATIONARY MODEL'
      ELSEIF (IFAULT .EQ. 12) THEN
         WRITE(*,*) '     NON-INVERTIBLE MODEL'
      ELSEIF (IFAULT .EQ. 13) THEN
         WRITE(*,*) '     I + M''H''HM NON P.D.'
      ENDIF
C
      END
C
C
